package xyz.fycz.myreader.util.utils

import xyz.fycz.myreader.util.IOUtils
import java.io.File
import java.io.FileInputStream
import java.math.BigInteger
import java.security.MessageDigest
import java.security.NoSuchAlgorithmException
import kotlin.experimental.and

/**
 * 将字符串转化为MD5
 */
@Suppress("unused")
object MD5Utils {

    fun md5Encode(str: String?): String {
        if (str == null) return ""
        var reStr = ""
        try {
            val md5: MessageDigest = MessageDigest.getInstance("MD5")
            val bytes: ByteArray = md5.digest(str.toByteArray())
            val stringBuffer: StringBuilder = StringBuilder()
            for (b in bytes) {
                val bt: Int = b.toInt() and 0xff
                if (bt < 16) {
                    stringBuffer.append(0)
                }
                stringBuffer.append(Integer.toHexString(bt))
            }
            reStr = stringBuffer.toString()
        } catch (e: NoSuchAlgorithmException) {
            e.printStackTrace()
        }

        return reStr
    }

    fun md5Encode16(str: String): String {
        var reStr = md5Encode(str)
        reStr = reStr.substring(8, 24)
        return reStr
    }


    /**
     * 获取单个文件的MD5值
     * @param file 文件
     * @param radix  位 16 32 64
     *
     * @return
     */
    fun getFileMD5s(file: File, radix: Int): String? {
        if (!file.isFile) {
            return null
        }
        val digest: MessageDigest?
        var `in`: FileInputStream? = null
        val buffer = ByteArray(1024)
        var len: Int
        try {
            digest = MessageDigest.getInstance("MD5")
            `in` = FileInputStream(file)
            while (`in`.read(buffer, 0, 1024).also { len = it } != -1) {
                digest.update(buffer, 0, len)
            }
        } catch (e: Exception) {
            e.printStackTrace()
            return null
        } finally {
            IOUtils.close(`in`)
        }
        val bigInt = BigInteger(1, digest!!.digest())
        return bigInt.toString(radix)
    }
}
